﻿/********************************************************************************/
/* 	map.d																		*/
/*------------------------------------------------------------------------------*/
/*	製作		D.K（あるふぁ～秘密基地）										*/
/*	製作開始	2008/05/22														*/
/*	MAIL		dk@red.interq.or.jp												*/
/*	URL			http://maglog.jp/alpha-secret-base/								*/
/*																				*/
/*	このソースは「やわらかライセンス」の元で配布されています。					*/
/*-更新履歴---------------------------------------------------------------------*/
/*	2008/05/22	初版															*/
/*-その他-----------------------------------------------------------------------*/
/*	なし																		*/
/********************************************************************************/

private import gamecore;
private import hell2;
private import boot;
private import actor;
private import vector;
private import keypad;

private import character;

private import fmfloader;

//********************************************************************************
// マップクラス
//********************************************************************************


class Map
{

	Layer2D layer_data; // 地形情報
	GameMain gamemain;

	this( )
	{
	}
	
	//-----------------------------------------------------------------------------
	//	初期化
	//-----------------------------------------------------------------------------
	//	引	数: なし
	//	戻り値: なし
	//-----------------------------------------------------------------------------
	void init( GameMain gamemain, Layer2D layer )
	{
		this.gamemain = gamemain;
		this.layer_data = layer;
	}
	
	//-----------------------------------------------------------------------------
	//	マップの移動
	//-----------------------------------------------------------------------------
	//	引	数: なし
	//	戻り値: なし
	//-----------------------------------------------------------------------------
	void move( )
	{
		
	}
	
	//-----------------------------------------------------------------------------
	//	マップの描画
	//-----------------------------------------------------------------------------
	//	引	数: なし
	//	戻り値: なし
	//-----------------------------------------------------------------------------
	void draw( )
	{
		int x = 0;
		int y = 0;

		Hell_drawTexture("bg"
			, 0
			, 0
			, 0
			, 0
			, gamemain.getScreenWidth( ) , gamemain.getScreenHeight( )
			, 1.0 , 1.0 );
		
		for ( x = 0; x < layer_data.width; x++ )
		{
			for ( y = 0; y < layer_data.height; y++ )
			{
				int x1 = ( x * layer_data.chip_width ) + ( layer_data.chip_width / 2 );
				int x2 = ( x * layer_data.chip_width ) - ( layer_data.chip_width / 2 );
				int y1 = ( y * layer_data.chip_height ) + ( layer_data.chip_height / 2 );
				int y2 = ( y * layer_data.chip_height ) - ( layer_data.chip_height / 2 );;

				int id = layer_data.get(x, y);
				if (( id < 255 ) && ( id != 0 ))
//				if ( id < 255 )
				{
/*
					if (
					     ( gamemain.view_point_x < x1 )
					  && ( ( gamemain.view_point_x + gamemain.getScreenWidth( ) ) > x2  )
					  && ( gamemain.view_point_y < y1 )
					  && ( ( gamemain.view_point_y + gamemain.getScreenHeight( ) ) > y2 )
					   )
*/
					{
//						int dx = ( ( x * layer_data.chip_width ) - ( layer_data.chip_width / 2 ) ) - gamemain.view_point_x;
//						int dy = ( ( y * layer_data.chip_height ) - ( layer_data.chip_height / 2 ) ) - gamemain.view_point_y;
						int dx = ( x * layer_data.chip_width );
						int dy = ( y * layer_data.chip_height );
						Hell_drawTexture("maptip"
							, dx
							, dy
							, ( id % 16 ) * layer_data.chip_width
							, ( id / 16 ) * layer_data.chip_height
							, layer_data.chip_width , layer_data.chip_height
							, 1.0 , 1.0 );
/*
							char[] str;
							str = std.string.format( "%d", id );
							Hell_drawFont(str , dx, dy , 1 , 255,255,255);
*/
					}
				}
			}
		}
	}
	

}

//********************************************************************************
